
_G.L = {}


-- Menu Headings

L["MenuTitle"] = "Combat Analysis";

L["General"] = "General";
L["Buffs"] = "Buff Info";
L["SaveLoad"] = "Save/Load";

-- Value/Date Formatting

L["Thousand"] = "K";
L["Million"] = "M";
L["Billion"] = "B";
L["Trillion"] = "T";

L["Jan"] = {"Jan","January"};
L["Feb"] = {"Feb","February"};
L["Mar"] = {"Mar","March"};
L["Apr"] = {"Apr","April"};
L["May"] = {"May","May"};
L["Jun"] = {"Jun","June"};
L["Jul"] = {"Jul","July"};
L["Aug"] = {"Aug","August"};
L["Sep"] = {"Sep","September"};
L["Oct"] = {"Oct","October"};
L["Nov"] = {"Nov","November"};
L["Dec"] = {"Dec","December"};

-- Options

L["ResetTotalsMessage"] = "Are you sure you want to reset totals?";
L["Yes"] = "Yes";
L["No"] = "No";
L["OK"] = "OK";

L["SaveData"] = "Save Data";
L["LoadData"] = "Load Data";

-- Select File Dialog

L["Select"] = "Select";
L["Save"] = "Save";
L["Load"] = "Load";
L["Cancel"] = "Cancel";

L["FileName"] = "File Name";

L["SelectAll"] = "Select All";
L["ClearAll"] = "Clear All";

L["Delete"] = "Delete";

L["AreYouSureYouWantToDeleteMessage"] = "Are you sure you want to Delete\nthe selected file(s)?";

L["Encounters"] = "Encounters";
L["Items"] = "Items";
L["CombineWith"] = "Combine With";
L["CombineInto"] = "Combine Into";

L["SelectCurrentDataToCombineWith"] = "Select Current Data to Combine with Loaded Data";
L["LoadDataAsTotalsEncounter"] = "Replace Totals Encounter with Loaded Data";

L["SelectSaveFile"] = "Select Save File";
L["SelectFileToLoad"] = "Select File To Load";
L["SelectDataToSave"] = "Select Data to Save";
L["SelectDataToCombineWith"] = "Combine With";

L["TooLong"] = "You may only enter up to 64 characters.";
L["IllegalCharacters"] = "You may only enter letters, digits, and spaces/underscores.";

L["NoDataMessage"] = "There is currently no data to Save.";
L["NoFileMessage"] = "No file specified.";
L["NoDataSelectedMessage"] = "No data has been selected.";
L["OverwriteFileMessage"] = "File already exists. Do you want to combine the saved data with this file or overwrite it?";
L["CombineOrSeparateMessage"] = "You have selected multiple files. Do you want to combine the data or load them separately?";
L["TooManyCharactersMessage"] = "The specified file name was too long\n(maximum length = 64 characters)";
L["InvalidCharactersMessage"] = "The specified file name contains\ninvalid characters.";
L["FileNotFoundMessage"] = "One of the specified files could not be found.";
L["SaveFailedMessage"] = "Save failed: ";
L["LoadFailedMessage"] = "Load failed: ";
L["CombineMessage"] = "Are you sure you want to combine\nthe selected files?";
L["LoadBeforeSaveMessage"] = "One of the selected files is currently being saved, and so cannot be loaded yet. Try again in around 10-15 seconds."

L["Combine"] = "Combine";
L["Overwrite"] = "Overwrite";
L["Combined"] = "Combined";
L["Separate"] = "Separate";

-- Commands

L["Options"] = "options";
L["Settings"] = "settings";
L["Setup"] = "setup";
L["CommandUsage"] = "usage: /ca "..L.Options.." | "..string.lower(L.Save).." | "..string.lower(L.Load);

-- Encounter Default Names

L["Totals"] = "Totals";
L["Encounter"] = "Encounter";
L["CurrentEncounter"] = "Current Encounter";
L["CompletedEncounter"] = "Completed Encounter";

-- Right Click Menu

L["RestoreTab"] = "Restore Tab";
L["CloseTab"] = "Close Tab";
L["AutoSelectPlayer"] = "Auto Select Player Details";
L["AutoHideTabs"] = "Auto Hide Tabs";
L["ShowBackground"] = "Show Background";
L["ShowMiniTitleBar"] = "Show Mini Title Bar";
L["ShowTitleAndDuration"] = "Show Title & Duration";
L["ShowEncountersList"] = "Show Encounters List";
L["ShowTargetsList"] = "Show Targets List";
L["ShowExtraButtons"] = "Show Extra Buttons";
L["AutoSelectNewEncounters"] = "Auto Select New Encounters";
L["ResetTotals"] = "Reset Totals";
L["ConfirmDialogOnReset"] = "Confirm Dialog on Reset";

-- Chat Menu (indexed by {command, channel name})

L["Say"] = {"say","Say"};
L["Fellowship"] = {"f","Fellowship"};
L["Raid"] = {"ra","Raid"};
L["Kinship"] = {"k","Kinship"};
L["Tribe"] = {"tr","Tribe"};
L["Gap"] = "------------------";

-- Other

L["AllPlayers"] = "All Players";
L["AllSkills"] = "All Skills";
L["Duration"] = "Duration";
L["SendToChat"] = "Send to Chat";
L["CombatAnalysisSummary"] = "Combat Analysis Summary";

L["DirectDamage"] = "Direct Damage";

L["MinutesAbbr"] = "m";
L["SecondsAbbr"] = "s";

L["Daze"] = "Daze";
L["Root"] = "Root";
L["Fear"] = "Fear";

-- Statistics Headings

L["AllData"] = "All Data";
L["NonCrits"] = "Non Crits";
L["Criticals"] = "Criticals";
L["Devastates"] = "Devastates";
L["CritsAndDevs"] = "Crits & Devs";
L["Partials"] = "Partials";

L["Total"] = "Total";
L["Average"] = "Average";
L["Maximum"] = "Maximum";
L["Minimum"] = "Minimum";

L["CriticalHits"] = "Critical Hits";

L["Avoidance"] = "Avoidance";
L["Attacks"] = "Attacks";
L["Hits"] = "Hits";
L["Absorbs"] = "Absorbs";
L["Misses"] = "Misses";
L["Immune"] = "Immune";
L["Resists"] = "Resists";
L["PhysicalAvoids"] = "Physical Avoids";
L["FullAvoids"] = "Full Avoids";
L["PartialAvoids"] = "Partial Avoids";
L["Avoids"] = "Avoids";
L["Blocks"] = "Blocks";
L["Parrys"] = "Parrys";
L["Evades"] = "Evades";
L["PartialBlocks"] = "Partial Blocks";
L["PartialParrys"] = "Partial Parrys";
L["PartialEvades"] = "Partial Evades";

L["Other"] = "Other";
L["Interrupts"] = "Interrupts";
L["CorruptionsRemoved"] = "Corruptions";

L["DmgTypes"] = "Damage Types";

L["TempMorale"] = "Temporary Morale";
L["RegularHeals"] = "Regular Heals";
L["TempHeals"] = "Temporary Heals";
L["WastedTempHeals"] = "  (wasted)";

-- Note the following elements are indexed by: {Short Name, Full Name}

L["Dmg"] = {"Dmg","Damage","DPS"}
L["Taken"] = {"Taken","Taken Damage","TPS"}
L["Heal"] = {"Heal","Heal","HPS"}
L["Power"] = {"Power","Power Restore","PPS"}

L["Debuff"] = {"Debuff","Debuff","Debuff"}
L["Buff"] = {"Buff","Buff","Buff"}

L["Death"] = {"Death","Death"}
L["Corruption"] = {"Corruption","Corruption Removal"}
L["Interrupt"] = {"Interrupt","Interrupt"}
L["CombatEntered"] = {"Combat Start","Entered Combat"}
L["CombatExited"] = {"Combat End","Exited Combat"}


L["AvoidanceEnum"] = {{"None","None"},{"Miss","Miss"},{"Immune","Immune"},{"Resist","Resist"},
                      {"Block","Block"},{"Parry","Parry"},{"Evade","Evade"},
                      {"P-Block","Partial Block"},{"P-Parry","Partial Parry"},{"P-Evade","Partial Evade"}}

L["CriticalEnum"] = {{"None","None"},{"Critical","Critical Hit"},{"Devastate","Devastating Hit"}}

L["DmgTypeEnum"] = {{"Common","Common"},{"Fire","Fire"},{"Lightn","Lightning"},{"Frost","Frost"},{"Acid","Acid"},{"Shadow","Shadow"},{"Light","Light"},
                    {"Bele","Beleriand"},{"West","Westernesse"},{"AD","Ancient Dorf"},{"None","None"}}

L["MoralePower"] = {{"Morale","Morale"},{"Power","Power"},{"None","None"}}




--[[

The complete parsing function. Since the order of text in the combat log is likely to differ in
different languages, this entire function is included  in the localization class.

The function is given an input line from the combat log, and parses that line to determine its meaning.
The final step in each section is to return the extracted values. These lines need not be updated, but
the correct info must be extracted into the relevant fields.

Note the use of numeric values for avoids, critical hits, dmg types, and morale/power. These numbers
correspond to the orderings in the four lists directly above this comment block.

You will need to know something about lua pattern matching and/or regex's to attempt to translate this
section. See http://www.lua.org/pil/20.2.html for more details.

]]--

L["Parse"] = function(line)

	-- 1) Damage line ---
	
	local initiatorName,avoidAndCrit,skillName,targetNameAmountAndType = string.match(line,"^(.*) scored a (.*)hit(.*) on (.*)%.$"); -- (updated in v4.1.0)
	
	if (initiatorName ~= nil) then
		
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		
		local avoidType =
			string.match(avoidAndCrit,"^partially blocked") and 8 or
			string.match(avoidAndCrit,"^partially parried") and 9 or
			string.match(avoidAndCrit,"^partially evaded") and 10 or 1;
		local critType =
			string.match(avoidAndCrit,"critical $") and 2 or
			string.match(avoidAndCrit,"devastating $") and 3 or 1;
		skillName = string.match(skillName,"^ with (.*)$") or L.DirectDamage; -- (as of v4.1.0)
		
		local targetName,amount,dmgType,moralePower = string.match(targetNameAmountAndType,"^(.*) for ([%d,]*) (.*)damage to (.*)$");
		-- damage was absorbed
		if targetName == nil then
			targetName = string.gsub(targetNameAmountAndType,"^[Tt]he ","");
			amount = 0;
			dmgType = 10;
			moralePower = 3;
		-- some damage was dealt
		else
			targetName = string.gsub(targetName,"^[Tt]he ","");
			amount = string.gsub(amount,",","")+0;
			-- note there may be no damage type
			dmgType = 
				dmgType == "Common " and 1 or
				dmgType == "Fire " and 2 or
				dmgType == "Lightning " and 3 or
				dmgType == "Frost " and 4 or
				dmgType == "Acid " and 5 or
				dmgType == "Shadow " and 6 or
				dmgType == "Light " and 7 or
				dmgType == "Beleriand " and 8 or
				dmgType == "Westernesse " and 9 or
				dmgType == "Ancient Dwarf-make " and 10 or 11;
			moralePower = (moralePower == "Morale" and 1 or moralePower == "Power" and 2 or 3);
		end
		
		-- Currently ignores damage to power
		if (moralePower == 2) then return nil end
		
		-- Update
		return 1,initiatorName,targetName,skillName,amount,avoidType,critType,dmgType;
	end
	
	-- 2) Heal line --
	--     (note the distinction with which self heals are now handled)
	--     (note we consider the case of heals of zero magnitude, even though they presumably never occur)
	local initiatorName,crit,skillNameTargetNameAmountAndType = string.match(line,"^(.*) applied a (.-)heal (.*)%.$");
	
	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		local critType =
			crit == "critical " and 2 or
			crit == "devastating " and 3 or 1;
		
		local skillNameTargetNameAndAmount,ending = string.match(skillNameTargetNameAmountAndType,"^(.*)to (.*)$");
		local targetName,skillName,amount;
		moralePower = (ending == "Morale" and 1 or (ending == "Power" and 2 or 3));
		-- heal was absorbed (unfortunately it appears this actually shows as a "hit" instead, so we never get into the first conditional)
		if (moralePower == 3) then
			targetName = string.gsub(ending,"^[Tt]he ","");
			amount = 0;
			-- skill name will equal nil if this was a self heal
			skillName = string.match(skillNameTargetNameAndAmount,"^with (.*) $");
		-- heal applied
		else
			skillName,targetName,amount = string.match(skillNameTargetNameAndAmount,"^(.*)to (.*) restoring ([%d,]*) points? $");
			targetName = string.gsub(targetName,"^[Tt]he ","");
			amount = string.gsub(amount,",","")+0;
			-- skill name will equal nil if this was a self heal
			skillName = string.match(skillName,"^with (.*) $");
		end
		
		-- rearrange if this was a self heal
		if (skillName == nil) then
			skillName = initiatorName;
			initiatorName = targetName;
		end
		
		-- Update
		return (moralePower == 2 and 4 or 3),initiatorName,targetName,skillName,amount,critType;
	end
	
	-- 3) Buff line --
	
	local initiatorName,skillName,targetName = string.match(line,"^(.*) applied a benefit with (.*) on (.*)%.$");
	
	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- Update
		return 17,initiatorName,targetName,skillName;
	end
	
	-- 4) Avoid line --
	local initiatorNameMiss,skillName,targetNameAvoidType = string.match(line,"^(.*) to use (.*) on (.*)%.$");
	
	if (initiatorNameMiss ~= nil) then
		initiatorName = string.match(initiatorNameMiss,"^(.*) tried$");
		local targetName, avoidType;
		-- standard avoid
		if (initiatorName ~= nil) then
			initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
			targetName,avoidType = string.match(targetNameAvoidType,"^(.*) but (.*) the attempt$");
			targetName = string.gsub(targetName,"^[Tt]he ","");
			avoidType = 
				string.match(avoidType," blocked$") and 5 or
				string.match(avoidType," parried$") and 6 or
				string.match(avoidType," evaded$") and 7 or
				string.match(avoidType," resisted$") and 4 or
				string.match(avoidType," was immune to$") and 3 or 1;
				
		-- miss
		else
			initiatorName = string.match(initiatorNameMiss,"^(.*) missed trying$");
			initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
			targetName = string.gsub(targetNameAvoidType,"^[Tt]he ","");
			avoidType = 2;
		end
		
		-- Sanity check: must have avoided in some manner
		if (avoidType == 1) then return nil end
		
		-- Update
		return 1,initiatorName,targetName,skillName,0,avoidType,1,10;
	end
	
	-- 5) Reflect line --
	
	local initiatorName,amount,dmgType,targetName = string.match(line,"^(.*) reflected ([%d,]*) (.*) to the Morale of (.*)%.$");
	
	if (initiatorName ~= nil) then
		local skillName = "Reflect";
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		targetName = string.gsub(targetName,"^[Tt]he ","");
		amount = string.gsub(amount,",","")+0;
		
		local dmgType = string.match(dmgType,"^(.*)damage$");
		-- a damage reflect
		if (dmgType ~= nil) then
			dmgType = 
				dmgType == "Common " and 1 or
				dmgType == "Fire " and 2 or
				dmgType == "Lightning " and 3 or
				dmgType == "Frost " and 4 or
				dmgType == "Acid " and 5 or
				dmgType == "Shadow " and 6 or
				dmgType == "Light " and 7 or
				dmgType == "Beleriand " and 8 or
				dmgType == "Westernesse " and 9 or
				dmgType == "Ancient Dwarf-make " and 10 or 11;
						
			-- Update
			return 1,initiatorName,targetName,skillName,amount,1,1,dmgType;
		-- a heal reflect
		else
			-- Update
			return 3,initiatorName,targetName,skillName,amount,1;
		end
	end
	
	-- 6) Temporary Morale bubble line (as of 4.1.0)
  local amount = string.match(line,"^You have lost ([%d,]*) points of temporary Morale!$");
	if (amount ~= nil) then
		amount = string.gsub(amount,",","")+0;
		
		-- the only information we can extract directly is the target and amount
		return 14,nil,player.name,nil,amount;
	end
	
	-- 7) Combat State Break notice (as of 4.1.0)
	
	-- 7a) Root broken
	local targetName = string.match(line,"^.* ha[sv]e? released (.*) from being immobilized!$");
	if (targetName ~= nil) then
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- the only information we can extract directly is the target name
		return 16,nil,targetName,nil;
	end
	
	-- 7b) Daze broken
	local targetName = string.match(line,"^.* ha[sv]e? freed (.*) from a daze!$");
	if (targetName ~= nil) then
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- the only information we can extract directly is the target name
		return 16,nil,targetName,nil;
	end
	
	-- 7c) Fear broken (TODO: Check)
	local targetName = string.match(line,"^.* ha[sv]e? freed (.*) from a fear!$");
	if (targetName ~= nil) then
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- the only information we can extract directly is the target name
		return 16,nil,targetName,nil;
	end
	
	-- 8) Interrupt line --
	
	local targetName, initiatorName = string.match(line,"^(.*) was interrupted by (.*)!$");
	
	if (targetName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- Update
		return 7,initiatorName,targetName;
	end
	
	-- 9) Dispell line (corruption removal) --
	
	local corruption, targetName = string.match(line,"You have dispelled (.*) from (.*)%.$");
	
	if (corruption ~= nil) then
		initiatorName = player.name;
		targetName = string.gsub(targetName,"^[Tt]he ","");
		
		-- NB: Currently ignore corruption name
		
		-- Update
		return 8,initiatorName,targetName;
	end
	
	-- 10) Defeat lines ---
	
	-- 10a) Defeat line 1 (mob or played was killed)
	local initiatorName = string.match(line,"^.* defeated (.*)%.$");
	
	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 10b) Defeat line 2 (mob died)
	local initiatorName = string.match(line,"^(.*) died%.$");

	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 10c) Defeat line 3 (a player was killed or died)
	local initiatorName = string.match(line,"^(.*) has been defeated%.$");

	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 10d) Defeat line 4 (you were killed)
	local match = string.match(line,"^.* incapacitated you%.$");

	if (match ~= nil) then
		initiatorName = player.name;
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 10e) Defeat line 5 (you died)
	local match = string.match(line,"^You have been incapacitated by misadventure%.$");

	if (match ~= nil) then
		initiatorName = player.name;
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 10f) Defeat line 6 (you killed a mob)
	local initiatorName = string.match(line,"^Your mighty blow topples (.*)%.$");
	
	if (initiatorName ~= nil) then
		initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
		
		-- Update
		return 9,initiatorName;
	end
	
	-- 11) Revive lines --
	
	-- 11a) Revive line 1 (player revived)
	local initiatorName = string.match(line,"^(.*) has been revived%.$");
	
	if (initiatorName ~= nil) then
	  initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
	  
		-- Update
	  return 10,initiatorName;
	end
	
	-- 11b) Revive line 2 (player succumbed)
	local initiatorName = string.match(line,"^(.*) has succumbed to .* wounds%.$");
	
	if (initiatorName ~= nil) then
	  initiatorName = string.gsub(initiatorName,"^[Tt]he ","");
	  
		-- Update
	  return 10,initiatorName;
	end
	
	-- 11c) Revive line 3 (you were revived)
	local match = string.match(line,"^You have been revived%.$");
	
	if (match ~= nil) then
	  initiatorName = player.name;
	  
		-- Update
	  return 10,initiatorName;
	end
	
	-- 11d) Revive line 4 (you succumbed)
	local match = string.match(line,"^You succumb to your wounds%.$");
	
	if (match ~= nil) then
	  initiatorName = player.name;
	  
		-- Update
	  return 10,initiatorName;
	end
	
	-- if we reach here, we were unable to parse the line
	--  (note there is very little that isn't parsed)
end



--[[
	
	Skill Names (for Temporary Morale & Buff/Debuff tracking)
	
	> Temporary Morale Skill Names need specify both how the skill name appears in the combat log, as
	    well as how it appears on the effect tooltip.
	
	> Buff Names must match exactly how the name of a skill appears in the effect tooltip.
	> Benefit/Debuff/Crowd-Control Names must match exactly how the name of a skill appears in the combat log.
	
--]]

-- 0) Temporary Morale Skills {combat log name, effect name}

-- Captain
L["ShieldOfTheDunedainTM"] = {"Shield of the D\195\186nedain","Shield of the D\195\186nedain"};
-- Champion
L["TrueHeroicsTM"] = {"True Heroics","True Heroics"};
L["SuddenDefenceTM"] = {"Sudden Defence","Sudden Defence"};
-- Minstrel
L["StoryOfTheHammerhandTM"] = {"Story of the Hammerhand","Story of the Hammerhand"};
L["SongOfTheHammerhandTM"] = {"Song of the Hammerhand","Song of the Hammerhand"};
L["GiftOfTheHammerhandTM"] = {"Gift of the Hammerhand","Gift of the Hammerhand"};
-- Rune-Keeper
L["WordOfExaltationTM"] = {"Word of Exaltation","Word of Exaltation"};
L["EssayOfExaltationTM"] = {"Essay of Exaltation","Word of Exaltation"};
-- Other
L["MartyrsFortitudeTM"] = {"Martyr's Fortitude","Martyr's Fortitude"};
L["FrostRingTM"] = {"Ring of Frost","Shield of the Blizzard"};

-- 1) Burglar Skills

-- Buffs (effect name)
L["TouchAndGo"] = "Touch and Go";
L["KnivesOut"] = "Knives Out";
L["Mischievous"] = "Mischievous";
L["QuietKnife"] = "Quiet Knife";
L["Gambler"] = "Gambler";
L["TheMischiefMaker"] = "The Mischief-maker";
L["TheQuietKnife"] = "The Quiet Knife";
L["TheGambler"] = "The Gambler";
L["Feint"] = "Feint";
L["ImprovedFeint"] = "Improved Feint";
L["ArmourOfTheUnseen"] = "Armour of the Unseen";
-- Debuffs (log name)
L["RevealWeakness"] = "Reveal Weakness";
L["Addle"] = "Addle";
L["TrickDisable"] = "Trick: Disable";
L["TrickCounterDefence"] = "Trick: Counter Defence";
L["TrickImprovedCounterDefence"] = "Trick: Improved Counter Defence";
L["TrickDustInTheEyes"] = "Trick: Dust in the Eyes";
L["Slowed"] = "Slowed";
L["TrickEnrage"] = "Trick: Enrage";
L["ASmallSnag"] = "A Small Snag";
L["QuiteASnag"] = "Quite a Snag";
-- Removals (log name)
L["MischievousDelight"] = "Mischievous Delight";
L["MischievousGlee"] = "Mischievous Glee";
-- Crowd Control (log name)
L["Riddle"] = "Riddle";
L["ImprovedRiddle"] = "Improved Riddle";
L["Confound"] = "Confound";
L["StartlingTwist"] = "Startling Twist";
L["ImprovedStartlingTwist"] = "Improved Startling Twist";
L["AdvancedStartlingTwist"] = "Advanced Startling Twist";
L["StunDustTier1"] = "Stun Dust Tier 1";
L["StunDustTier2"] = "Stun Dust Tier 2";
L["StunDustTier3"] = "Stun Dust Tier 3";
L["ExploitOpening"] = "Exploit Opening";
L["Trip"] = "Trip";
L["MarblesTier1"] = "Marbles Tier 1";
L["MarblesTier2"] = "Marbles Tier 2";
L["MarblesTier3"] = "Marbles Tier 3";

-- 2) Captain Skills

-- Buffs (effect name)
L["MusterCourage"] = "Muster Courage";
L["InHarmsWay"] = "In Harm's Way";
L["WarCry"] = "War-cry";
L["BladeOfElendil"] = "Blade of Elendil";
L["Motivated"] = "Motivated";
L["OnGuard"] = "On Guard";
L["RelentlessAttack"] = "Relentless Attack";
L["Focus"] = "Focus";
L["ShieldBrother"] = "Shield-brother";
L["WatchfulShieldBrother"] = "Watchful Shield-brother";
L["SongBrother"] = "Song-brother";
L["BladeBrother"] = "Blade-brother";
L["ToArmsShieldBrother"] = "To Arms (Shield-brother)";
L["ToArmsFellowshipShieldBrother"] = "To Arms (Fellowship Shield-brother)";
L["ToArmsSongBrother"] = "To Arms (Song-brother)";
L["ToArmsFellowshipSongBrother"] = "To Arms (Fellowship Song-brother)";
L["ToArmsBladeBrother"] = "To Arms (Blade-brother)";
L["ToArmsFellowshipBladeBrother"] = "To Arms (Fellowship Blade-brother)";
L["StrengthOfWillShieldBrother"] = "Strength of Will (Shield-brother)";
L["StrengthOfWillFellowshipShieldBrother"] = "Strength of Will (Fellowship Shield-brother)";
L["StrengthOfWillSongBrother"] = "Strength of Will (Song-brother)";
L["StrengthOfWillFellowshipSongBrother"] = "Strength of Will (Fellowship Song-brother)";
L["StrengthOfWillBladeBrother"] = "Strength of Will (Blade-brother)";
L["StrengthOfWillFellowshipBladeBrother"] = "Strength of Will (Fellowship Blade-brother)";
L["RallyingCry"] = "Rallying Cry";
L["InDefenceOfMiddleEarth"] = "In Defence of Middle-earth";
L["DefensiveStrike"] = "Defensive Strike";
L["ImprovedDefensiveStrike"] = "Improved Defensive Strike";
L["LastStand"] = "Last Stand";
-- Debuffs (log name)
L["NobleMark"] = "Noble Mark";
L["TellingMark"] = "Telling Mark";
L["RevealingMark"] = "Revealing Mark";

-- 3) Champion Skills

-- Buffs (effect name)
L["Fervour"] = "Fervour";
L["Glory"] = "Glory";
L["Ardour"] = "Ardour";
L["ControlledBurn"] = "Controlled Burn";
L["Flurry"] = "Flurry";
L["SuddenDefence"] = "Sudden Defence";
L["SeekingBlades"] = "Seeking Blades";
L["Adamant"] = "Adamant";
L["Invincible"] = "Invincible";
-- Benefits (log name)
L["EbbingIre"] = "Ebbing Ire";
L["RisingIre"] = "Rising Ire";

-- 4) Guardian Skills

-- Buffs (effect name)
L["Protection"] = "Protection";
L["ProtectionByTheSword"] = "Protection by the Sword";
L["ShieldWall"] = "Shield Wall";
L["GuardiansBlockStance"] = "Guardian's Block Stance";
L["GuardiansParryStance"] = "Guardian's Parry Stance";
L["Overpower"] = "Overpower";
L["GuardiansThreatStance"] = "Guardian's Threat Stance";
L["GuardiansPledge"] = "Guardian's Pledge";
L["GuardiansWard"] = "Guardian's Ward";
L["ImprovedGuardiansWard"] = "Improved Guardian's Ward";
L["GuardiansWardTactics"] = "Guardian's Ward Tactics";
L["ImprovedGuardiansWardTactics"] = "Improved Guardian's Ward Tactics";
L["WarriorsBlock"] = "Warrior's Block";
L["WarriorsParry"] = "Warrior's Parry";
L["WarriorsPower"] = "Warrior's Power";
L["WarriorsThreat"] = "Warrior's Threat";
-- Debuffs (log name)
L["Challenge"] = "Challenge";
L["ImprovedChallenge"] = "Improved Challenge";
L["ChallengeTheDarkness"] = "Challenge the Darkness";
L["ImprovedOverwhelm"] = "Improved Overwhelm";
L["ImprovedSting"] = "Improved Sting";
L["ImminentCleansing"] = "Imminent Cleansing";

-- 5) Hunter Skills

-- Buffs (effect name)
L["StanceStrength"] = "Stance: Strength";
L["StancePrecision"] = "Stance: Precision";
L["StanceEndurance"] = "Stance: Endurance";
L["BurnHot"] = "Burn Hot";
L["CoolBurn"] = "Cool Burn";
L["Fleetness"] = "Fleetness";
L["ImprovedFleetness"] = "Improved Fleetness";
L["SwiftStroke"] = "Swift Stroke";
L["NeedfulHaste"] = "Needful Haste";
L["HuntersArt"] = "Hunter's Art";
-- Crowd Control (log name)
L["DazingBlow"] = "Dazing Blow";
L["ImprovedDazingBlow"] = "Improved Dazing Blow";
L["DistractingShot"] = "Distracting Shot";
L["RainOfThorns"] = "Rain of Thorns";
L["CryOfThePredator"] = "Cry of the Predator";
L["BardsArrow"] = "Bard's Arrow";
L["TrapDamage"] = "Trap Damage";

-- 6) Lore-Master Skills

-- Buffs (effect name)
L["AirLore"] = "Air-lore";
L["ContinualAirLore"] = "Continual Air-lore";
L["SignOfPowerRighteousness"] = "Sign of Power: Righteousness";
L["SignOfPowerVigilance"] = "Sign of Power: Vigilance";
L["SignOfTheWildRage"] = "Sign of the Wild: Rage";
L["ImprovedSignOfTheWildRage"] = "Improved Sign of the Wild: Rage";
L["SignOfTheWildProtection"] = "Sign of the Wild: Protection";
-- Debuffs (log name)
L["KnowledgeOfTheLoreMaster"] = "Knowledge of the Lore-master";
L["GustOfWind"] = "Gust of Wind";
L["FireLore"] = "Fire-lore";
L["WindLore"] = "Wind-lore";
L["FrostLore"] = "Frost-lore";
L["AncientCraft"] = "Ancient Craft";
L["SignOfPowerCommand"] = "Sign of Power: Command";
L["ImprovedSignOfPowerCommand"] = "Improved Sign of Power: Command";
L["SignOfPowerSeeAllEnds"] = "Sign of Power: See All Ends";
-- Crowd Control (log name)
L["BlindingFlash"] = "Blinding Flash";
L["ImprovedBlindingFlash"] = "Improved Blinding Flash";
L["BaneFlare"] = "Bane Flare";
L["HerbLore"] = "Herb-lore";
L["CrackedEarth"] = "Cracked Earth";

-- 7) Minstrel Skills

-- Buffs (effect name)
L["AnthemOfWar"] = "Anthem of War";
L["AnthemOfTheFreePeoples"] = "Anthem of the Free Peoples";
L["AnthemOfProwess"] = "Anthem of Prowess";
L["AnthemOfComposure"] = "Anthem of Composure";
L["TheMelodyOfBattle"] = "The Melody of Battle";
L["InspireFellows"] = "Inspire Fellows";
L["SoliloquyOfSpirit"] = "Soliloquy of Spirit";
L["ImprovedChordOfSalvation"] = "Improved Chord of Salvation";
L["TaleOfHeroism"] = "Tale of Heroism";
L["TaleOfBattle"] = "Tale of Battle";
L["TaleOfWarding"] = "Tale of Warding";
L["TaleOfWardingAndHope"] = "Tale of Warding and Hope";
L["TaleOfFrostAndFlame"] = "Tale of Frost and Flame";
L["TaleOfFrostAndFlamesBattle"] = "Tale of Frost and Flame's Battle";
L["TaleOfWardingAndHeroism"] = "Tale of Warding and Heroism";
L["SymphonyOfTheHopefulHeart"] = "Symphony of the Hopeful Heart";
L["Harmony"] = "Harmony";
L["WarSpeech"] = "WarSpeech";
L["AnthemOfCompassion"] = "Anthem of Compassion";
L["AnthemOfTheThirdAge"] = "Anthem of the Third Age";
L["AnthemOfTheThirdAgeWarSpeech"] = "Anthem of the Third Age (War-speech)";
L["AnthemOfTheThirdAgeHarmony"] = "Anthem of the Third Age (Harmony)";
L["MinorBallad"] = "Minor Ballad";
L["MajorBallad"] = "Major Ballad";
L["PerfectBallad"] = "Perfect Ballad";
L["StillAsDeath"] = "Still As Death";
-- Crowd Control (log name)
L["SongOfTheDead"] = "Song of the Dead";
L["InvocationOfElbereth"] = "Invocation of Elbereth";

-- 8) Rune-Keeper Skills

-- Buffs (effect name)
L["DoNotFallToStorm"] = "Do Not Fall to Storm";
L["DoNotFallToFlame"] = "Do Not Fall to Flame";
L["DoNotFallToWinter"] = "Do Not Fall to Winter";
L["DoNotFallThisDay"] = "Do Not Fall This Day";
L["ShallNotFallThisDay"] = "Shall Not Fall This Day";
L["PreludeToHope"] = "Prelude to Hope";
L["RuneOfRestoration"] = "Rune of Restoration";
L["WritOfHealthTier1"] = "Writ of Health - Tier 1";
L["WritOfHealthTier2"] = "Writ of Health - Tier 2";
L["WritOfHealthTier3"] = "Writ of Health - Tier 3";
L["OurFatesEntwined"] = "Our Fates Entwined";
L["AllFatesEntwined"] = "All Fates Entwined";
L["GloriousForeshadowing"] = "Glorious Foreshadowing";
L["WondrousForeshadowing"] = "Wondrous Foreshadowing";

-- 9) Warden Skills

-- Buffs (effect name)
L["Conviction"] = "Conviction";
L["DeterminationStance"] = "Determination Stance";
L["Conservation"] = "Conservation";
L["Recklessness"] = "Recklessness";
L["WayOfTheWarden"] = "Way of the Warden";
L["ShieldBashBlock"] = "Shield-bash - Block";
L["WallOfSteelParry"] = "Wall of Steel - Parry";
L["AdroitManoeuvre"] = "Adroit Manoeuvre";
L["WardensTriumph"] = "Warden's Triumph";
L["DefensiveStrikeBlock"] = "Defensive Strike - Block";
L["Persevere"] = "Persevere";
L["ShieldMastery"] = "Shield-mastery";
L["ShieldDefence"] = "Shield-defence";
L["ShieldTactics"] = "Shield-tactics";
L["DanceOfBattleEvade"] = "Dance of Battle - Evade";
L["TacticallySound"] = "Tactically Sound";
L["T1HealOverTime"] = "Tier 1 Heal over Time";
L["T2HealOverTime"] = "Tier 2 Heal over Time";
L["T3HealOverTime"] = "Tier 3 Heal over Time";
L["T4HealOverTime"] = "Tier 4 Heal over Time";

-- 10) Racial Skills
L["DutyBound"] = "Duty Bound";
L["DwarfEndurance"] = "Dwarf Endurance"; -- TODO: Check

-- Other
L["StunImmunity"] = "Stun Immunity";
